﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using Infragistics.Windows.DataPresenter;

namespace GridTesting
{
    public class ViewModel
    {
        public ViewModel()
        {

            // ------------------- Field Layouts

            var collection = new ObservableCollection<FieldLayout>();

            var layout = new FieldLayout { IsDefault = true };
            layout.Fields.Add(new Field { Name = "FirstName", Label = "First Name" });

            collection.Add(layout);

            FieldLayouts = collection;

            // -------------------- Data

            var people = new ObservableCollection<Person>();

            for (var i = 0; i < 10; i++)
            {
                people.Add(new Person());
            }

            DataCollection = people;
        }

        public ObservableCollection<FieldLayout> FieldLayouts { get; set; }
        public ObservableCollection<Person> DataCollection { get; set; }
    }

    public class Person
    {
        private readonly Random _random;
        public string FirstName { get; set; }
        public string MiddleName { get; set; }
        public string LastName { get; set; }
        public string Id { get; set; }

        public Person()
        {
            _random = new Random();
            FirstName = GenerateRandomString();
            MiddleName = GenerateRandomString();
            LastName = GenerateRandomString();
            Id = GenerateRandomString();
        }

        private string GenerateRandomString()
        {
            String randomString = @"";
            int stringLength = _random.Next(5, 12);

            //Loop ‘length’ times to generate a random number or character
            for (int i = 0; i < stringLength; i++)
            {
                int randNumber = _random.Next(1, 3) == 1 ? _random.Next(97, 123) : _random.Next(48, 58);

                //append random char or digit to random string
                randomString = randomString + (char)randNumber;
            }
            //return the random string
            return randomString;
        }
    }
}
